--[[--
 * 战斗事件管理器(一场战斗对应一个对象)
 * @author GWJ
 * 
]]

local fightEventManager = class("fightEventManager")
local eventProtcocol=require("src.framework.api.EventProtocol")
eventProtcocol.extend(fightEventManager)

function fightEventManager:ctor()
	--事件队列
	self.SimulationQueue={}
end

--设置战斗信息
function fightEventManager:setFightLogsData(fightLogs)
	self.fightLogs=fightLogs
	--当前回合
	self.momentRoundNum=1
	--当前战斗事件
	self.momentFight=1
	--当前动作
	self.momentAction=1
end

--获取当前进行的动作
function fightEventManager:getMomentAction()
	local fightRounds=self.fightLogs:getFightRounds()
	--最大回合
	if self.momentRoundNum>#fightRounds
		print("fight end")
		return nil
	end
	--当前回合战斗上限
	local fightLogs=fightRounds[self.momentRoundNum]:getFightLogs()
	if self.momentFight>#fightLogs then
		self.momentRoundNum=self.momentRoundNum+1
		self:getMomentAction()
		return
	end
	--当前回合动作上线
	local fightActions=fightLogs[self.momentFight]:getActions()
	if self.momentAction>#fightActions then
		self.momentFight=self.momentFight+1
		--通知回合切换显示
		local roundEvent={}
		roundEvent.name="FIGHT_UPDATEROUND"
		roundEvent.data=v:getRoundNum()
		self:dispatchEvent(roundEvent)
		self:getMomentAction()
		return
	end
	local action=fightActions[self.momentAction]
	return action
end

--[[
	开始执行模拟事件
]]
function fightEventManager:beginSimulation()
	--计时器ID
	self.PauseResume_pauseEntry=nil
	--当前事件使用时间(单位:秒)
	local duration
	local scheduler=cc.Director:getInstance():getScheduler()
	local function start()
		local action=self:getMomentAction()
		if not action then return end
		duration=0
		--事件计时器回调
		local function simulationComplete()
			scheduler:unscheduleScriptEntry(self.PauseResume_pauseEntry)
			self.PauseResume_pauseEntry=nil
			start()
		end
		local event={}
		event.name="FIGHTEVENT_PERFORM"
		event.type=
		
		
		self:dispatchEvent(event)
		self.PauseResume_pauseEntry = scheduler:scheduleScriptFunc(simulationComplete,duration,false)
	end
	start()
	return nil
end

function setEventData(eventData)
	self.eventData=eventData
end

function fightEventManager:clean()
	self:removeAllEventListeners()
	if self.PauseResume_pauseEntry then
		local scheduler=cc.Director:getInstance():getScheduler()
		scheduler:unscheduleScriptEntry(self.PauseResume_pauseEntry)
	end
	print("fightEventManager is clean")
end

return fightEventManager